﻿using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Services.Optimization.Billing.Interfaces;

namespace HeuristicLab.Services.Optimization.Billing.Business {
  public class MockupBillingService : IOptimizationBilling {

    private static IList<Model.Product> products;
    private static IDictionary<string, IList<Model.Order>> userToOrders;
    private static IList<Model.Order> allOrders;

    static MockupBillingService() {
      products = new List<Model.Product>();
      products.Add(new Model.Product() {
        Name = "Optimization-as-a-Service - Experiment execution",
        Description = "Create and run your experiments within HeuristicLab Hive",
        ProductId = 1,
        Price = 10.0,
        ProductType = "Optimization Service"
      });
      products.Add(new Model.Product() {
        Name = "Whatever-o-matic - Experiment execution",
        Description = "Another fine product",
        ProductId = 2,
        Price = 100.0,
        ProductType = "Product"
      });

      userToOrders = new Dictionary<string, IList<Model.Order>>();
      allOrders = new List<Model.Order>();
    }

    public IList<Model.Product> GetProducts() {
      return products;
    }

    public void SaveOrder(Model.Order order) {
      IList<Model.Order> orders;
      if (!userToOrders.TryGetValue(order.User.Name, out orders)) {
        userToOrders[order.User.Name] = orders = new List<Model.Order>();
      }
      orders.Add(order);
      allOrders.Add(order);
    }

    public IList<Model.Order> GetOrdersByState(Model.OrderState state) {
      return (from o in allOrders where o.State == state select o).ToList();
    }
  }
}
