﻿using System.Collections.Generic;
using System.Net.Security;
using System.ServiceModel;
using HeuristicLab.Services.Optimization.Billing.Model;

namespace HeuristicLab.Services.Optimization.Billing.Interfaces {
  [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
  public interface IOptimizationBilling {
    [OperationContract]
    IList<Product> GetProducts();

    // payment methods via enumeration

    [OperationContract]
    void SaveOrder(Order order);

    [OperationContract]
    IList<Order> GetOrdersByState(OrderState state);
  }
}
